﻿Type=StaticCode
Version=4.2
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
	Private Sql1 As SQL
	Private Rs As  ResultSet
	Private strSql As String
End Sub

Public Sub sql_IsInitialized As Boolean
	Return Sql1.IsInitialized
End Sub

Public Sub InitSql
	Sql1.InitializeSQLite(File.DirApp, "Sokoban.db", True)
	Sql1.ExecNonQuery("CREATE TABLE IF NOT EXISTS Images (Id INTEGER PRIMARY KEY, Img BLOB)")
	Sql1.ExecNonQuery("CREATE TABLE IF NOT EXISTS Undo (Seq INTEGER PRIMARY KEY, " & _
														"uDir CHAR, " & _
														"FromX INTEGER, FromY INTEGER, " & _
														"ToX INTEGER, ToY INTEGER)")
	Sql1.ExecNonQuery("CREATE TABLE IF NOT EXISTS Games (Num INTEGER PRIMARY KEY, nChars TEXT)")
	Sql1.ExecNonQuery("CREATE TABLE IF NOT EXISTS Score (Num INTEGER PRIMARY KEY, Name VARCHAR(20), Moves INTEGER, Time VARCHAR(8))")
End Sub

Public Sub Clear_Undo
	Sql1.ExecNonQuery("DELETE FROM Undo")
End Sub

Public Sub Save_Undo(ud As UndoT)
	Dim Seq As Int
	strSql = "Select Max(Seq) as Sq From Undo Order by Seq desc limit 1"
	Rs = Sql1.ExecQuery(strSql)
	If Rs.NextRow Then
		Seq = Rs.GetInt("Sq") + 1
	End If
	Rs.Close
	strSql="INSERT INTO Undo VALUES(" & Seq & ", '" & ud.uDir & "', " & ud.FromX & ", " & ud.FromY & ", " & ud.ToX & ", " & ud.ToY & ")"
	Sql1.ExecNonQuery(strSql)	
End Sub

Public Sub Load_Undo As UndoT
	Dim Seq As Int
	Dim Ret As UndoT
	strSql = "Select Max(Seq) as Sq From Undo Order by Seq desc limit 1"
	Rs = Sql1.ExecQuery(strSql)
	Seq = Rs.GetInt("Sq") 
	If Seq = 0 Then
		Ret.uDir = "A"
		Ret.FromX = -1
		Ret.FromY = -1
		Rs.Close
		Return Ret
	End If
	Rs.Close
	strSql = "Select * From Undo WHERE (Seq = " & Seq  & ")"
	Rs = Sql1.ExecQuery(strSql)
	If Rs.NextRow Then
		Ret.uDir = Rs.GetString("uDir")
		Ret.FromX = Rs.GetInt("FromX")
		Ret.FromY = Rs.GetInt("FromY")
		Ret.ToX = Rs.GetInt("ToX")
		Ret.ToY = Rs.GetInt("ToY")
		Sql1.ExecNonQuery("DELETE FROM Undo WHERE (Seq = " & Seq  & ")")
	End If
	Rs.Close
	Return Ret
End Sub

Public Sub insert_Image(id As Int, im As Image)
	strSql="INSERT INTO Images VALUES(" & id & ",  " & Null & ")"
	Sql1.ExecNonQuery(strSql)	
	Dim Out As OutputStream
	Dim Buffer() As Byte
	Out.InitializeToBytesArray(10000)
	im.WriteToStream(Out)
	Buffer = Out.ToBytesArray
	Out.Close 
	strSql="UPDATE Images SET Img = ? WHERE (Id = " & id  & ")"
	Sql1.ExecNonQuery2(strSql, Array As Object(Buffer))
End Sub

Public Sub Get_Image(id As Int) As Image
	Dim Buffer() As Byte 
	Dim InpStr As InputStream
	Dim tmpImg As Image 
	strSql = "Select Img From Images WHERE(Id = " & id & ")"
	Rs = Sql1.ExecQuery(strSql)
	If Rs.NextRow Then
		Buffer = Rs.GetBlob("Img")
		InpStr.InitializeFromBytesArray(Buffer, 0, Buffer.Length)
		tmpImg.Initialize2(InpStr)
		InpStr.Close
	End If
	Rs.close
	Return tmpImg
End Sub

Public Sub Save_New_Game(nChars(,) As Char)
	Dim str As String
	Dim Separ As String = ""
	Dim NewNum As Int 
	strSql = "Select Max(Num) as N From Games"
	Rs = Sql1.ExecQuery(strSql)
	NewNum = Rs.GetInt("N") + 1
	str = ""
	For y = 0 To 19
		str = str & Separ
		For x = 0 To 19
			str = str & nChars(x, y)
		Next
		Separ = ","
	Next
	Rs.close
	strSql="INSERT INTO Games VALUES(" & NewNum & ", '" & str & "')"   
	Sql1.ExecNonQuery(strSql)	
End Sub

Public Sub Load_Game(Gm As Int) As Char(,)
	Dim tbRet(20, 20) As Char
	Dim qtTarget, qtWall, qtBox As Int 
	strSql = "Select nChars From Games Where(Num = " & Gm & ")"
	Rs = Sql1.ExecQuery(strSql)
	If Rs.NextRow Then
		Dim str As String = Rs.GetString("nChars")
		Dim yChars() As String = Regex.Split(",", str)
		For y = 0 To yChars.Length - 1
			For x = 0 To yChars(y).Length - 1
				tbRet(x, y) = yChars(y).SubString2(x, x + 1)
				If tbRet(x, y) <> "X" Then
					If tbRet(x, y) = "+" Then		'Robot and Target
						qtTarget = qtTarget + 1
					Else if tbRet(x, y) = "*" Then	'Box and Target
						qtBox = qtBox + 1
						qtTarget = qtTarget + 1
					Else if tbRet(x, y) = "." Then	'Target
						qtTarget = qtTarget + 1
					Else If tbRet(x, y) = "$" Then	'Box
						qtBox = qtBox + 1
					else if tbRet(x, y) = "#" Then	'Wall
						qtWall = qtWall + 1
					End If
				End If							
			Next 
		Next
	End If
	Main.qTarget= qtTarget
	Main.qBox 	= qtBox
	Main.qWall 	= qtWall
	Rs.close
	Return tbRet
End Sub

Public Sub GetLst(lstV As ListView)
	lstV.Items.Clear
	strSql = "Select Num From Games Order by Num Asc"
	Rs = Sql1.ExecQuery(strSql)
	Do While Rs.NextRow
		lstV.Items.Add(NumberFormat2((Rs.GetInt("Num")), 4, 0, 0, False))
	Loop
	Rs.close
End Sub

Public Sub View_Score(Gm As Int) As String
	Dim strRet As String
	strSql = "Select * From Score Where(Num = " & Gm & ")"
	Rs = Sql1.ExecQuery(strSql)
	If Rs.NextRow Then
		strRet = Rs.GetString("Name") & "," & Rs.GetInt("Moves") & "," & Rs.GetString("Time")
		Rs.Close
	Else
		strRet = "None"
	End If
	Return strRet
End Sub

Public Sub Save_Score(Gm As Int, Nm As String, Mvs As Int, Tm As String)
	strSql="INSERT INTO Score VALUES(" & Gm & ", '" & Nm & "' , " & Mvs & ", '" & Tm & "')"   
	Sql1.ExecNonQuery(strSql)
End Sub

Public Sub Update_Score(Gm As Int, Nm As String, Mvs As Int, Tm As String)
	strSql="DELETE From Score Where(Num = " & Gm & ")"
	Sql1.ExecNonQuery(strSql)
	Save_Score(Gm, Nm, Mvs, Tm)	   
End Sub

Public Sub Close_Sql
	Sql1.close
End Sub
